diff -Naur linux_old/drivers/mtd/nand/nand_base.c linux/drivers/mtd/nand/nand_base.c
--- linux_old/drivers/mtd/nand/nand_base.c	2009-05-02 14:54:43.000000000 -0400
+++ linux/drivers/mtd/nand/nand_base.c	2010-05-06 11:43:59.000000000 -0400
@@ -2159,8 +2159,31 @@
 
 	/* Do call back function */
 	if (!ret)
+	{		
 		mtd_erase_callback(instr);
-
+	}
+	else
+	{	
+		/* 
+		*  This section of code is added for  Samsung chip ( Manufacturer ID: 0x20, Chip ID: 0xda/0xdc ,ST Micro NAND 256MiB/512MiB
+		*  3,3V 8-bit ) that  choose the "RAM based BBT table" and this table was NOT updated when the Bad block was found 
+		*  while erasing "pages" of the block ( due to bad block occuring during its life time). 
+		*
+		* Note : "Flash based BBT" chip uses "nand_update_bbt" to update the BBT in "flash" and RAM BBT . But same function returns 
+		* ENVAL ( invalid argument ) if td = NULL . For Samsung chip , td is made as NULL when chosen as defualt RAM BBT Table    
+		*/
+ 
+		printk(KERN_ALERT "BAD block found at page  : 0x%08x \n", page );
+		printk(KERN_ALERT "Updating the RAM based BBT Table ..... \n");
+		
+		/* Write 0x00 at 1st and 2nd OOB at this page( Invalid page ),corresponding block is Marked as Invalid Block  */ 
+		chip->block_markbad (mtd, instr->fail_addr);
+		printk(KERN_ALERT "RAM BBT Table updated \n");
+		
+		/*Update the RAM based BBT table with the New Bad Block , so future nand  write/erase shall skip this block */
+		chip->scan_bbt(mtd);
+		printk(KERN_ALERT "\n *** Try erasing the same partition again *** \n");
+	}
 	/*
 	 * If BBT requires refresh and erase was successful, rewrite any
 	 * selected bad block tables
