--- uboot/board/VSC452EVB/VSC452EVB.c	2014-12-02 10:28:32.531135000 -0500
+++ uboot/board/VSC452EVB/VSC452EVB.c	2014-12-02 10:50:03.672971000 -0500
@@ -21,87 +21,20 @@
  * MA 02111-1307 USA
  */
 
-/*
- * Copyright (c) 2012 - Network Appliance Inc.
- * mv88e6176 driver code and Razor driver code
- */
-
-/****************************************************************
-****************************************************************
-**                                                            **
-**    (C)Copyright 2008-2009, American Megatrends Inc.        **
-**                                                            **
-**            All Rights Reserved.                            **
-**                                                            **
-**       5555 Oakbrook Parkway,Building 200, Norcross,        **
-**                                                            **
-**        Georgia - 30093, USA. Phone-(770)-246-8600.         **
-**                                                            **
-****************************************************************
-**  mdcio driver implementation
-**
-**
-**************************************************************/
-
-
-
 #include <common.h>
 #include <command.h>
 #include <asm/mipsregs.h>
 #include <asm/io.h>
 #include <vsc452/vsc452regs.h>
-#include <linux/mtd/compat.h>
-#include <asm/errno.h>
-#include "enet_switch/mv88e6176_regdefs.h"
-#include "enet_switch/mv88e6176.h"
-#include "enet_switch/enet_switch.h"
-//#include "soc/gpio_vsc.h"
-//#include "gpio/gpio_info.h"
-
-/* Version Number of this module */
-#define SAMPLE_MAJOR	1
-#define SAMPLE_MINOR	0
-
-#define	dbgprint	if(Debug_Enable) printk
-
-#define MDCIO_MAX_DEVICES	1
-#define MDCIO_MAX_CHANNEL       (MDCIO_MAX_DEVICES - 1)
-
-#define MDCIO_MAJOR	250
-#define MDCIO_DEV_NAME	"mdcio"
 
 #define BOOTARGS_MEMSIZE_LENGTH 30
 
-#define CLK_LOW		0
-#define CLK_HIGH	1
-
-#define DATA_LOW	0
-#define DATA_HIGH	1	 
-
-/* Constants */
-#define OPT_CTRL_REG	(*(unsigned long *)0xB02008A4)
-
-/* Mdcio enable mask  */
-#define MDCIO_ENABLE	0x00000C00
-
-/* gpio pins for data and clock for channel 0 and 1*/
-int mdcio_data_pin [ 2 ] = { 16 };
-int mdcio_clk_pin [ 2 ] = { 17 }; 
-
-
-/* Prototypes */
-static int drive_clock(int channel, int data);
-static int data_out(int channel, int data);
-static int data_in(int channel);
-static int dir_out(int channel);
-static int open_drain(int channel);
-static int read_reg ( unsigned int channel,unsigned int phyaddr,unsigned int regnum );
-static int write_reg ( unsigned int channel,unsigned int phyaddr, unsigned int regnum, unsigned int data );
-
 #define MAX_GPIO_PORTS          5
 #define MAX_GPIOS		80
 #define GPIO_PORT0		0x10200a00
 #define GPIO_OFFSET		4
+#define OUTPUT_LOW	0x00000000
+#define OUTPUT_HIGH	0x00000001
 #define INPUT_INTR_DISABLE	0x00000003
 #define GPIO(port, number)	GPIO_PORT0 + (port *0x40) + (number * GPIO_OFFSET)
 #define PHY_RESET		GPIO(1,11)
@@ -110,29 +43,30 @@
 #define TIMER_4_CURRENT_COUNT   0x10200184
 #define TIMER_4_MODE_CONTROL    0x10200190
 #define TIMER_4_INT_STATUS      0x10200194
-
+#define PARALLEL_CHIP_SELECT_1_CTRL	0x10200004
 /* GPIO assignments for determining if a platform is Razor_L/M/S,
 */
-#define RAZOR_ON_ATT
-#ifdef RAZOR_ON_ATT
-#define GPIO_PORT_RAZOR_L        0
-#define GPIO_PIN_RAZOR_L        11
-#define GPIO_PORT_RAZOR_S_M      0
-#define GPIO_PIN_RAZOR_S_M       3
-#define PLATFORM_RAZOR_L  GPIO(GPIO_PORT_RAZOR_L,GPIO_PIN_RAZOR_L)
-#define PCM_RAZOR_M       GPIO(GPIO_PORT_RAZOR_S_M,GPIO_PIN_RAZOR_S_M)
-#else
-/*TBD. Change to actual GPIOs for Razor once they are defined */
-#define GPIO_PORT_RAZOR_L        0
-#define GPIO_PIN_RAZOR_L        11
-#define GPIO_PORT_RAZOR_S_M      0
-#define GPIO_PIN_RAZOR_S_M       3
-#define PLATFORM_RAZOR_L  GPIO(GPIO_PORT_RAZOR_L,GPIO_PIN_RAZOR_L)
-#define PCM_RAZOR_M       GPIO(GPIO_PORT_RAZOR_S_M,GPIO_PIN_RAZOR_S_M)
-#endif
+/* Three GPIOs determine platform type in Razor
 
-int mdcio_read_reg( unsigned int channel, unsigned int phyaddr, unsigned int regnum, unsigned int *data );
-int mdcio_write_reg ( unsigned int channel, unsigned int phyaddr, unsigned int regnum, unsigned int data );
+   CLT_TYPE_0, port 3,7 (from SP side)
+   CLT_TYPE_1, port 3,8 (from SP side)
+   CLT_TYPE_2, port 3,9 (from SP side)
+
+   CLT_TYPE_0     CLT_TYPE_1     CLT_TYPE_2
+          0                      1                     1                   Razor L
+          0                      1                     0                   Razor M
+          0                      0                     1                   Razor S
+*/
+   
+#define PLATSEL_GPIO_PORT_HI        3
+#define PLATSEL_GPIO_PIN_HI         7
+#define PLATSEL_GPIO_PORT_MID       3
+#define PLATSEL_GPIO_PIN_MID        8
+#define PLATSEL_GPIO_PORT_LO        3
+#define PLATSEL_GPIO_PIN_LO         9
+#define PLATFORM_SEL_HI   GPIO(PLATSEL_GPIO_PORT_HI, PLATSEL_GPIO_PIN_HI)
+#define PLATFORM_SEL_MID  GPIO(PLATSEL_GPIO_PORT_MID,PLATSEL_GPIO_PIN_MID)
+#define PLATFORM_SEL_LO   GPIO(PLATSEL_GPIO_PORT_LO, PLATSEL_GPIO_PIN_LO)
 
 void UbootWatchdogEnable(void);
 void UbootWatchdogDisable(void);
@@ -202,7 +136,18 @@
 
 	for(i=0; i < MAX_GPIOS; i++)
 	{
-		write32((GPIO_PORT0+(i*GPIO_OFFSET)), INPUT_INTR_DISABLE);
+        if((i==35) || (i==36) || (i==37)){
+        /* Set Fan Fault as outputs */
+        /* This prevents glitches on those pins when the gpio driver initializes */
+		    write32((GPIO_PORT0+(i*GPIO_OFFSET)), OUTPUT_HIGH);
+        }
+        else if(i == 70){
+            /* Set JTAG MFG to output low */
+		    write32((GPIO_PORT0+(i*GPIO_OFFSET)), OUTPUT_LOW);
+        }
+        else{
+		    write32((GPIO_PORT0+(i*GPIO_OFFSET)), INPUT_INTR_DISABLE);
+        }
 	}
 
 	/* Clear all pending GPIO interrupt */
@@ -225,20 +170,20 @@
  */
 int checkboard (void)
 {
-// please see burt 496567 for why this has been removed
-// left here for historical purposes, this causes problems on the Vespa board
-#if 0
+	int i;
 	write32(PHY_RESET, 0); /* Toggle the reset line of the PHY */
 	udelay(10);
 	write32(PHY_RESET, 1);
-#endif 	
-	int i;
+
 	/* Clear all pending I2C interrupt */
 	for (i = 0; i < 6; i++)
 	{
 		*((unsigned long *)(0xB0200504 + i*0x80)) = 1<<7;
 	}
- 	
+	
+       /* Enable the SP access of FPGA registers via Flash Chip select 1 (FSC1)  */
+	write32(PARALLEL_CHIP_SELECT_1_CTRL, 0x00000012);
+
 	return 0;
 }
 
@@ -419,99 +364,65 @@
 				strcpy (env_platformid , "Absolut");
 				break ;
 			}
-#ifdef RAZOR_ON_ATT
-/* TBD. Use actual PLAT string when defined for Razor */
-			if (0 == strncmp(TempBuf, "SB_XIX", 7))
+
+			if (0 == strncmp(TempBuf, "SB_XXII", 8))
 			{
-                                sprintf(debugbuff, "%x", read32(PLATFORM_RAZOR_L));
-                                setenv("GPIO73", debugbuff);
-                                sprintf(debugbuff, "%x", read32(PCM_RAZOR_M));
-                                setenv("GPIO61", debugbuff);
-                                /* Since ATT and Vespa share the same PLAT 
-                                                            identifier, we need to differentiate them here.
-                                                         */
-                                /* Check for GPIO 73(PCH), which is SP GPIO 0/11,  
-                                                              to see if it's an ATT or a Vespa Platform. 
-                                                             GPIO will be asserted for Vespa
-                                                        */
-                       		if ((read32(PLATFORM_RAZOR_L) & 0x01) == 1) {
-                                        strcpy (env_platformid, "RazorL");
-                       		}
-                                else { 
-                                        /* It's an ATT platform.  Check GPIO 61(PCH), which is
-                                                                          SP GPIO 0/3, to see if it's
-                                                                           a Helix or Zuma.  GPIO will be asserted if PCM is Zuma.
-                                       	                            */
-                                       	if ((read32(PCM_RAZOR_M) & 0x01) == 1) {
-                                       	        strcpy (env_platformid, "RazorM");
+                                sprintf(debugbuff, "%x", read32(PLATFORM_SEL_HI));
+                                setenv("GP 3,7 CLT-0", debugbuff);
+                                sprintf(debugbuff, "%x", read32(PLATFORM_SEL_MID));
+                                setenv("GP 3,8 CLT-1", debugbuff);
+                                sprintf(debugbuff, "%x", read32(PLATFORM_SEL_LO));
+                                setenv("GP 3,9 CLT-2", debugbuff);
+
+                       		if ((read32(PLATFORM_SEL_HI) & 0x01) == 0) {
+
+                                        if ( ((read32(PLATFORM_SEL_MID) & 0x01) == 1) && 
+                                             ((read32(PLATFORM_SEL_LO) & 0x01) == 1)) {
+                                             
+                                            strcpy (env_platformid, "RazorL");
                                         }
-                                        else {
-                                                strcpy (env_platformid, "RazorS");
-                               		}
-                               	}
-                                		
-				break ;
-			}
-#else
-			if (0 == strncmp(TempBuf, "SB_XIX", 7))
-			{
-                                sprintf(debugbuff, "%x", read32(PLATFORM_RAZOR_L));
-                                setenv("GPIO73", debugbuff);
-                                sprintf(debugbuff, "%x", read32(PCM_RAZOR_M));
-                                setenv("GPIO61", debugbuff);
-                                /* Since ATT and Vespa share the same PLAT 
-                                                            identifier, we need to differentiate them here.
-                                                         */
-                                /* Check for GPIO 73(PCH), which is SP GPIO 0/11,  
-                                                              to see if it's an ATT or a Vespa Platform. 
-                                                             GPIO will be asserted for Vespa
-                                                        */
-                       		if ((read32(PLATFORM_RAZOR_L) & 0x01) == 1) {
-                                        strcpy (env_platformid, "RazorL");
-                       		}
-                                else { 
-                                        /* It's an ATT platform.  Check GPIO 61(PCH), which is
-                                                                          SP GPIO 0/3, to see if it's
-                                                                           a Helix or Zuma.  GPIO will be asserted if PCM is Zuma.
-                                       	                            */
-                                       	if ((read32(PCM_RAZOR_M) & 0x01) == 1) {
-                                       	        strcpy (env_platformid, "RazorM");
+                                        else if ( ((read32(PLATFORM_SEL_MID) & 0x01) == 1) && 
+                                             ((read32(PLATFORM_SEL_LO) & 0x01) == 0)) {
+                                             
+                                            strcpy (env_platformid, "RazorM");
+                                        }
+                                        else if ( ((read32(PLATFORM_SEL_MID) & 0x01) == 0) && 
+                                             ((read32(PLATFORM_SEL_LO) & 0x01) == 1)) {
+                                             
+                                            strcpy (env_platformid, "RazorS");
                                         }
-                                        else {
-                                                strcpy (env_platformid, "RazorS");
-                               		}
-                               	}
+ 
+                       		}
                                 		
 				break ;
 			}
-#endif
 			
 		} 
 		
 	}
 	if (i >= 256-6)
 	{
-//		printf("Did not find platfromid in FruBuf\n");
+		printf("Did not find platfromid in FruBuf\n");
 
-//#define myprintable(x) (((x)>=0x20)&&((x)<=0x7E))
-//		int j;
-//	    for (i = 0; i < 16; ++i) {
-//			for (j = 0; j < 16; j++) {
-//				printf ("%02X ", FruBuf[i * 16 + j]);
-//			}
-//			printf (" ");
-//
-//			for (j = 0; j < 16; j++) {
-//				unsigned char   ch = (char)FruBuf[i * 16 + j];
-//
-//				if (myprintable(ch)) {
-//					printf ("%c", ch);
-//				} else {
-//					printf ("-");
-//				}
-//			}
-//			printf ("\n");
-//		}
+#define myprintable(x) (((x)>=0x20)&&((x)<=0x7E))
+		int j;
+	    for (i = 0; i < 16; ++i) {
+			for (j = 0; j < 16; j++) {
+				printf ("%02X ", FruBuf[i * 16 + j]);
+			}
+			printf (" ");
+
+			for (j = 0; j < 16; j++) {
+				unsigned char   ch = (char)FruBuf[i * 16 + j];
+
+				if (myprintable(ch)) {
+					printf ("%c", ch);
+				} else {
+					printf ("-");
+				}
+			}
+			printf ("\n");
+		}
 
 		return -1;
 	}
@@ -579,538 +490,10 @@
 	strcpy (buf, platformid);
 	return strlen(platformid);
 }
-
-
-
-/* MDCIO DRIVER CODE START */
-
-/* Read register from switch */
-static int read_reg (unsigned int channel,unsigned int phyaddr ,unsigned int regnum )
-{
-	/* 0x60 in the MSB indicates start condition with read operation  */
-	unsigned long data = 0x6000;
-	unsigned int reg_data = 0;
-	int temp = 0;
-	int i =0;
-
-	/* embed the phyaddr and regnum with start condition and read cmd */
-	phyaddr = phyaddr << 7;
-	data = data | phyaddr;
-	regnum = regnum << 2;
-	data = data | regnum;
-
-    /*Sending Initial 32 bit preamble*/
-	open_drain(channel);
-	for ( i =0; i < 32; i++)
-        {
-		drive_clock(channel, CLK_LOW);
-		drive_clock(channel, CLK_HIGH);
-        }
-	
-	/* set data pin direction out */
-	dir_out(channel);
-
-	/* or start condition, phyaddr, regnum, ta and receive data */
-	for ( i =0; i < 14; i++)
-        {
-		drive_clock(channel, CLK_LOW);
-                if ( data & (1 << (15 -i) ))
-                        data_out(channel, DATA_HIGH);
-                else
-                        data_out(channel, DATA_LOW);
-
-                drive_clock(channel, CLK_HIGH);
-        }
-	
-	/* do the turn around */
-	open_drain(channel);
-	
-	drive_clock(channel, CLK_LOW);
-        drive_clock(channel, CLK_HIGH);
-
-	temp = 2;	
-	i = 0;
-	while ( i < 25 )
-	{
-		temp = data_in(channel);
-	        if (temp==0)
-        	{
-			break;
-		}
-		i++;
-	}	
-
-	if ( i  >= 25 )
-	{
-		printk(KERN_ERR "Device not responding\n");
-        return -1;
-	}
-	drive_clock(channel, CLK_LOW);
-
-	/* Read the data */
-	for ( i=0; i < 16; i++ )
-	{
-		drive_clock(channel,CLK_HIGH);
-		temp = data_in(channel);
-		temp = (temp << ( 15 - i));
-		reg_data = reg_data | temp;
-		drive_clock(channel, CLK_LOW );
-	}
-
-	/*Sending Last 32 Idle bits */
-	open_drain(channel);
-	for ( i =0; i < 32; i++)
-        {
-		drive_clock(channel, CLK_HIGH);
-		drive_clock(channel, CLK_LOW);
-        }
-    
-	return reg_data;
-}
-
-
-/* Write in the switch register */
-static int write_reg (unsigned int channel,unsigned int phyaddr ,unsigned int regnum,unsigned int reg_data )
-{
-	/* 50 in the msb indicates start condition with write cmd */
-	unsigned long data = 0x50000000;
-	int i = 0;
-
-	/* embed the phyaddr and regnum with the start condition and write cmd*/
-        phyaddr = phyaddr << 23;
-        data = data | phyaddr;
-        regnum = regnum << 18;
-        data = data | regnum;
-        
-	/*Sending Initial 32 bit preamble*/
-	open_drain(channel);
-	for ( i =0; i < 32; i++)
-        {
-		drive_clock(channel, CLK_LOW);
-		drive_clock(channel, CLK_HIGH);
-        }
-
-	/* set data pin direction out */
-        dir_out(channel);
-	
-	/* or start condition,phy addr, reg num, data*/
-	for ( i =0; i < 14; i++)
-	{
-		drive_clock(channel, CLK_LOW);
-		if ( data & (1 << (31 -i) ))	
-		{
-			data_out(channel, DATA_HIGH);
-		}
-		else
-		{
-			data_out(channel, DATA_LOW);
-		}
-		drive_clock(channel, CLK_HIGH);		
-	}
-	
-	/*do the turn around*/
-	drive_clock(channel,CLK_LOW);
-	data_out(channel,DATA_HIGH);
-	drive_clock(channel, CLK_HIGH);
-	
-	drive_clock(channel, CLK_LOW);
-	data_out(channel, DATA_LOW);
-	drive_clock(channel, CLK_HIGH);
-
-	/* write the data  */	
-	for ( i=0; i < 16; i++ )
-	{
-		drive_clock( channel, CLK_LOW);
-		if ( reg_data & ( 1 << (15 -i)))
-			data_out(channel, DATA_HIGH);
-		else
-			data_out(channel, DATA_LOW);
-		drive_clock( channel, CLK_HIGH);
-	}
-
-	/* put the data line in opendrain */
-	open_drain(channel);
-	for ( i =0; i < 32; i++)
-        {
-		drive_clock(channel, CLK_LOW);
-		drive_clock(channel, CLK_HIGH);
-        }
-
-	return 0;
-}
-
-/* Drive Clock  */
-static int drive_clock(int channel,int data)
-{
-    unsigned int port = mdcio_clk_pin[ channel ] / 16;
-    unsigned int pin = mdcio_clk_pin[ channel ] % 16;
-
-    write32( GPIO(port,pin) , data );
-
-	udelay(50);
-
-	return 0;
-}
-
-
-/* Direction Out */
-static int dir_out(int channel)
-{
-    unsigned int port = mdcio_data_pin[ channel ] / 16;
-    unsigned int pin = mdcio_data_pin[ channel ] % 16;
-
-    write32( GPIO(port,pin) , 0 );
-
-	udelay(50);
-    return 0;
-}
-
-/* Data Out */
-static int data_out(int channel, int data )
-{
-    unsigned int port = mdcio_data_pin[ channel ] / 16;
-    unsigned int pin = mdcio_data_pin[ channel ] % 16;
-
-    write32( GPIO(port,pin) , data );
-
-	return 0;
-}
-
-
-/* Data In */
-static int data_in(int channel)
-{
-    unsigned int port = mdcio_data_pin[ channel ] / 16;
-    unsigned int pin = mdcio_data_pin[ channel ] % 16;
-
-    return read32( GPIO(port,pin) ) & 0x1;
-}
- 
-
-/* Open drain */
-static int open_drain(int channel)
-{
-    unsigned int port = mdcio_data_pin[ channel ] / 16;
-    unsigned int pin = mdcio_data_pin[ channel ] % 16;
-
-    write32( GPIO(port,pin) , 0x3 );
-
-	return 0;
-}
-
- int 
-mdcio_read_reg ( unsigned int channel, unsigned int phyaddr, unsigned int regnum, unsigned int *data)
-{
-	int retval; 
-
-	if (channel > MDCIO_MAX_CHANNEL) {
-		printk(KERN_ERR "mdcio_read_reg: request received for invalid "
-				"channel %d\n", channel);
-		/* Cant return an error code here, so return -1 */
-		return -1;
-	}
-
-	*data = read_reg(channel, phyaddr, regnum);
-
-	if ( *data == -1 )
-		retval  = -1;
-	else 
-		retval = 0;
-
-	return retval;
-}
-
-int 
-mdcio_write_reg ( unsigned int channel, unsigned int phyaddr, unsigned int regnum, unsigned int data )
-{
-	if (channel > MDCIO_MAX_CHANNEL) {
-		printk(KERN_ERR "mdcio_read_reg: request received for invalid "
-				"channel %d\n", channel);
-		/* Cant return an error code here, so return -1 */
-		return -1;
-	}
-
-	return write_reg(channel, phyaddr, regnum, data);
-}
-
-/* MDCIO DRIVER CODE END */
-
-
-
-/* ATT-SPECIFIC MARVELL 88E6176 CODE START */
-
-static unsigned int port_to_phy_dev_addr_map[MRV_88E6176_MAX_PORTS] = {
-    MRV_88E6176_PHY0_DEV_ADDR,      // port 0 is associated to phy 0
-    MRV_88E6176_PHY1_DEV_ADDR,      // port 1 is associated to phy 1
-    MRV_88E6176_PHY2_DEV_ADDR,      // port 2 is associated to phy 2
-    MRV_88E6176_PHY3_DEV_ADDR,      // port 3 is associated to phy 3
-    MRV_88E6176_PHY4_DEV_ADDR,      // port 4 is associated to phy 4
-    MRV_88E6176_PHY_UNKNOWN_ADDR ,  // port 5 has no phy.
-    MRV_88E6176_PHY_UNKNOWN_ADDR    // port 6 has no phy.
-} ;
-
-static int mv88e6176_read_reg(unsigned int phyaddr, unsigned int regnum, unsigned int *data)
-{
-    int retval = 0 ;
-    if ( data == NULL )
-        return -EINVAL ;
-
-    retval = mdcio_read_reg(0, phyaddr, regnum, data);
-    return retval ;
-}
-
-static int mv88e6176_write_reg(unsigned int phyaddr, unsigned int regnum, unsigned int data)
-{
-    int retval = 0 ;
-    retval = mdcio_write_reg(0, phyaddr, regnum, data) ;
-    return retval ;
-}
-
-static int mv88e6176_validate_phy_params(unsigned int dev_addr, unsigned int page_addr, unsigned int reg_addr)
-{
-    if ( ( dev_addr  >=  MRV_88E6176_PHY_START_DEV_ADDR  )  && ( dev_addr  <=  MRV_88E6176_PHY_END_DEV_ADDR) &&
-         ( page_addr >=  MRV_88E6176_PHY_PAGE_START_ADDR )  && ( page_addr <=  MRV_88E6176_PHY_PAGE_END_ADDR ) &&
-         ( reg_addr  >=  MRV_88E6176_PHY_REG_START_ADDR  )  && ( reg_addr  <  MRV_88E6176_PHY_REG_END_ADDR ) ) {
-        return 0 ;
-    }
-    else {
-        return -EINVAL ;
-    }
-}
-
-static int mv88e6176_indirect_send_op(int dev_addr, int reg_addr, unsigned int data, unsigned short op)
-{
-    int retval = 0 ;
-    int rval = 0 ;
-    unsigned char iter = 0 ;
-    unsigned char busybit = 1 ;
-
-    // Indirect writes are done only for phy registers. So validate for phy addresses.
-    // Validation is for dev_addr and reg_addr, so let the page_addr be a correct value of 0.
-    retval = mv88e6176_validate_phy_params(dev_addr, 0 , reg_addr) ;
-    if ( retval == 0 ) {
-
-        // Write SMI_DATA register with value.
-        retval = mv88e6176_write_reg(MRV_88E6176_GLOBAL2_DEV_ADDR, MRV_88E6176_GLOBAL2_SMI_PHY_DATA_REG_ADDR, data) ;
-        if ( retval == 0 ) {
-
-            // Write to SMI_CONTROL global register giving the operation to perform.
-            retval = mv88e6176_write_reg(MRV_88E6176_GLOBAL2_DEV_ADDR, MRV_88E6176_GLOBAL2_SMI_PHY_COMMAND_REG_ADDR, op) ;
-            if ( retval == 0 ) {
-                // Wait until the SMIBusy bit becomes 0.
-                while ( ( iter < SMI_BUSY_BIT_ITER_MAX ) && ( busybit == 1 ) && ( retval == 0 ) ) {
-                    retval = mv88e6176_read_reg(MRV_88E6176_GLOBAL2_DEV_ADDR, MRV_88E6176_GLOBAL2_SMI_PHY_COMMAND_REG_ADDR,&rval) ;
-                    busybit = ( rval & MRV_88E6176_GLOBAL2_SMI_PHY_COMMAND_REG_SMIBUSY_MASK ) >> MRV_88E6176_GLOBAL2_SMI_PHY_COMMAND_REG_SMIBUSY_SHIFT ;
-                    iter++ ;
-                    udelay(SMI_BUSY_BIT_DELAY) ;
-                    rval = 0 ;
-                }
-
-                if ( ( busybit ) || ( retval != 0 ) ) {
-                    printk("%s:: busybit is still set, or retval != 0, rval = %d, retval = 0x%x \n", __FUNCTION__, rval, retval ) ;
-                    return -EINVAL  ; // Return error here.
-                }
-            }
-        }
-    }
-    return retval ;
-}
-
-static int mv88e6176_indirect_read_reg(int dev_addr, int reg_addr, int *data)
-{
-    int retval = 0 ;
-    unsigned short op = 0 ;
-    int rval = 0 ;
-    // int channel = 0 ; // There is only 1 channel on Buell.
-
-    if ( data == NULL )
-        return -EINVAL ;
-
-    op = ( 1 << MRV_88E6176_GLOBAL2_SMI_PHY_COMMAND_REG_SMIBUSY_SHIFT ) |
-         ( MRV_88E6176_GLOBAL2_SMI_PHY_COMMAND_REG_SMIMODE_VAL_CLAUSE_22 <<MRV_88E6176_GLOBAL2_SMI_PHY_COMMAND_REG_SMIMODE_SHIFT ) |
-         ( MRV_88E6176_GLOBAL2_SMI_PHY_COMMAND_REG_SMIOP_VAL_SMIMODE_1_READ_DATA_REG << MRV_88E6176_GLOBAL2_SMI_PHY_COMMAND_REG_SMIOP_SHIFT ) |
-         ( dev_addr << MRV_88E6176_GLOBAL2_SMI_PHY_COMMAND_REG_DEV_ADDR_SHIFT ) |
-         ( reg_addr << MRV_88E6176_GLOBAL2_SMI_PHY_COMMAND_REG_REG_ADDR_SHIFT ) ;
-
-    // data arg is 0, because we want to clear up content on data register.
-    retval = mv88e6176_indirect_send_op(dev_addr, reg_addr, 0, op) ;
-    if ( retval == 0 ) {
-        // Read from SMI_DATA global register.
-        retval = mv88e6176_read_reg( MRV_88E6176_GLOBAL2_DEV_ADDR, MRV_88E6176_GLOBAL2_SMI_PHY_DATA_REG_ADDR,&rval) ;
-        if ( retval == 0 ) {
-            *data = rval ;
-        }
-    }
-    return retval ;
-}
-
-static int mv88e6176_indirect_write_reg(int dev_addr, int reg_addr, int data)
-{
-    unsigned short op = 0 ;
-
-    // Write to SMI_CONTROL global register giving the instruction to write the dev addr's register.
-    op = ( 1 << MRV_88E6176_GLOBAL2_SMI_PHY_COMMAND_REG_SMIBUSY_SHIFT ) |
-         ( MRV_88E6176_GLOBAL2_SMI_PHY_COMMAND_REG_SMIMODE_VAL_CLAUSE_22 <<MRV_88E6176_GLOBAL2_SMI_PHY_COMMAND_REG_SMIMODE_SHIFT ) |
-         ( MRV_88E6176_GLOBAL2_SMI_PHY_COMMAND_REG_SMIOP_VAL_SMIMODE_1_WRITE_DATA_REG << MRV_88E6176_GLOBAL2_SMI_PHY_COMMAND_REG_SMIOP_SHIFT ) |
-         ( dev_addr << MRV_88E6176_GLOBAL2_SMI_PHY_COMMAND_REG_DEV_ADDR_SHIFT ) |
-         ( reg_addr << MRV_88E6176_GLOBAL2_SMI_PHY_COMMAND_REG_REG_ADDR_SHIFT ) ;
-
-    return ( mv88e6176_indirect_send_op(dev_addr, reg_addr, data, op) ) ;
-}
-
-
-static int mv88e6176_set_pagenum(int dev_addr, int page_num)
-{
-    int retval = 0 ;
-    unsigned int wval = 0 ;
-    unsigned int data = 0 ;
-
-    // Pass a valid value for register address.
-    retval = mv88e6176_validate_phy_params(dev_addr, page_num, 0 ) ;
-    if ( retval == 0 ) {
-        // Read page register.
-        retval = mv88e6176_indirect_read_reg(dev_addr, MRV_88E6176_PHY_DEV_PAGE_ADDR_REG , &data) ;
-        if ( retval == 0 ) {
-            // Set page number.
-            wval = (data & ~MRV_88E6176_PHY_DEV_PAGE_ADDR_REG_PAGE_SELECT_MASK ) | page_num ;
-
-            // Write the page number back.
-            retval = mv88e6176_indirect_write_reg(dev_addr, MRV_88E6176_PHY_DEV_PAGE_ADDR_REG, wval) ;
-        } else  {
-            retval = -EINVAL ;
-        }
-    } else {
-        retval = -EINVAL ;
-    }
-
-    return retval ;
-}
-
-int mv88e6176_phy_read_reg(unsigned int dev_addr, unsigned int page_addr, unsigned int reg_addr, unsigned int *value )
-{
-    int retval = 0 ;
-
-    if ( value == NULL ) 
-        return -EINVAL ;
-
-    *value = 0 ;
-    // Validate register address ranges and return error if needed.
-    retval = mv88e6176_validate_phy_params(dev_addr, page_addr, reg_addr) ;
-    if ( retval == 0 ) {
-        // Set page number, perform an indirect read.
-        retval = mv88e6176_set_pagenum(dev_addr, page_addr) ;
-        if ( retval == 0 ) {
-            // Now read the actual register, perform an indirect read.
-            retval = mv88e6176_indirect_read_reg(dev_addr, reg_addr,value) ;
-            if ( retval != 0 ) {
-                printk("(F)%s indirect read reg",__FUNCTION__ ) ;
-            }
-        } else {
-            printk("(F)%s set pagenum ",__FUNCTION__ ) ;
-        }
-    } else {
-       printk("(F)%s validate params dev_addr = 0x%x, page_num = 0x%x, reg_addr = 0x%x \n",__FUNCTION__,dev_addr, page_addr, reg_addr  ) ;
-    }
-
-    return retval ;
-}
-
-int mv88e6176_phy_write_reg(unsigned int dev_addr, unsigned int page_addr, unsigned int reg_addr, unsigned int value )
-{
-    int retval = 0 ;
-
-    // Validate register address ranges and return error if needed.
-    retval = mv88e6176_validate_phy_params(dev_addr, page_addr, reg_addr) ;
-    if ( retval == 0 ) {
-        // Set page number, perform an indirect read.
-        retval = mv88e6176_set_pagenum(dev_addr, page_addr) ;
-        if ( retval == 0 ) {
-            // Now write to actual register, perform an indirect write.
-            retval = mv88e6176_indirect_write_reg(dev_addr, reg_addr,value) ;
-            if ( retval != 0 ) {
-                printk("(F)%s indirect write reg",__FUNCTION__ ) ;
-            }
-        } else {
-            printk("(F)%s set pagenum ",__FUNCTION__ ) ;
-        }
-    } else {
-       printk("(F)%s validate params dev_addr = 0x%x, page_num = 0x%x, reg_addr = 0x%x \n",__FUNCTION__,dev_addr, page_addr, reg_addr  ) ;
-    }
-
-
-    return retval ;
-}
-
-
-int mv88e6176_power_down(unsigned int port_num, unsigned int wval)
-{
-    int retval = 0 ;
-    unsigned int temp = 0 ;
-
-    if ( port_num >=  MRV_88E6176_MAX_PORTS )
-        return -EINVAL ;
-
-    // Port numbers and Phys are mapped one to one.
-    // Port 0 is associated to Phy 0, etc.
-    // But there are only 5 phys and 7 ports.
-    // ports 5, 6 don't have a phy associated to them.
-    if ( port_to_phy_dev_addr_map[port_num] == MRV_88E6176_PHY_UNKNOWN_ADDR ) {
-        retval = -EINVAL ;
-    } else {
-	    retval = mv88e6176_phy_read_reg( port_to_phy_dev_addr_map[port_num], MRV_88E6176_PAGE_0 , MRV_88E6176_PHY_COPPER_CTRL_REG , &temp) ;
-	    if ( retval == 0 ) {
-		    temp = ( temp & ~MRV_88E6176_PHY_CU_CTRL_REG_POWER_DOWN_MASK ) | ( wval <<  MRV_88E6176_PHY_CU_CTRL_REG_POWER_DOWN_SHIFT ) ;
-                retval = mv88e6176_phy_write_reg( port_to_phy_dev_addr_map[port_num], MRV_88E6176_PAGE_0 , MRV_88E6176_PHY_COPPER_CTRL_REG , temp) ;
-
-            // Now write into register 16, page 0 also.
-	        retval = mv88e6176_phy_read_reg( port_to_phy_dev_addr_map[port_num], MRV_88E6176_PAGE_0 , MRV_88E6176_COPPER_SPECIFIC_CONTROL_REG1_REG_ADDR , &temp) ;
-            if ( retval == 0 ) {
-                temp = ( temp & ~MRV_88E6176_PHY_CU_SPECIFIC_CONTROL_REG1_POWER_DOWN_MASK ) |
-                       ( wval <<  MRV_88E6176_PHY_CU_SPECIFIC_CONTROL_REG1_POWER_DOWN_SHIFT ) ;
-                retval = mv88e6176_phy_write_reg( port_to_phy_dev_addr_map[port_num], MRV_88E6176_PAGE_0 ,
-                                                  MRV_88E6176_COPPER_SPECIFIC_CONTROL_REG1_REG_ADDR , temp) ;
-            }
-        }
-    }
-    return retval ;
-}
-
-/* ATT-SPECIFIC MARVELL 88E6176 CODE END */
-
-
 void platform_specific_funcs(void) {
         char plat_str[256];
-        unsigned int test;
-        int i = 0;
-        int port;
-        int pin;
-        
-        int temp;
-        int reg_num;
-        unsigned int midplane_port;
         char *bootargs;
 
-        /*This is the same for all ENTRY PLATFORMS (Vespa / Zuma / Helix)!!*/
-        printk(KERN_ALERT "MDCIO  Driver Version %d.%d\n",SAMPLE_MAJOR,SAMPLE_MINOR);
-        printk(KERN_ALERT "Copyright (c) 2007 American Megatrends Inc.\n");
-
-        OPT_CTRL_REG &= (~MDCIO_ENABLE);	 
-
-        /* Initialize clock as output and data in open drain */	
-        for ( i = 0; i < MDCIO_MAX_DEVICES; i++)
-        {
-        	/* configure clock as output and set high */
-            port = mdcio_clk_pin[i] / 16;
-            pin = mdcio_clk_pin[i] % 16;
-
-            write32( GPIO(port,pin) , 0 );
-
-            drive_clock(i,CLK_HIGH);
-            drive_clock(i,CLK_LOW);
-		
-            /* configure data pin as open drain */
-            open_drain(i);
-        }
 
         /* If needed, update bootcmd to include memory size
          * If there is currently a "memsize" environmemt variable, do nothing
@@ -1126,64 +509,4 @@
                 }
         }
 
-        readplatformid(plat_str);
-        if (!strncmp(plat_str,"RazorL",6)) {
-
-                #define CPLD_BASE       (0x16000000)
-                /* Arm CPLD register upon cold boot */
-                if (((read32(0x102008A8)) & 0xFF) == 0x56)
-                {
-                        udelay (9000000);
-                        write32((CPLD_BASE + 0x0120), 0xFFFF);
-                        write32((CPLD_BASE + 0x0140), 0xFFFF);
-                        write32((CPLD_BASE + 0x0180), 0xFFFF);
-                }
-                /* Set GPIO Port 3 Control to allow XDP Communication */
-                write32 (0x10200838, 0);
-
-                //confirmed in BURT 487463 referenced in controller_switch_src.txt
-                midplane_port = 3;
-                //confirmed by switch_vespa_mod.c -
-                //      misprint in Broadcom datasheet, see register 0x3C page 154
-                reg_num = 0x1e;
-                test = mdcio_read_reg(0, midplane_port, reg_num, &temp);
-                if (test == 0) {
-
-                    temp = 0x8; // set bit 3 to 1 to "super isolate" the phy
-                    test = mdcio_write_reg(0, midplane_port, reg_num, temp); 
-                    if(test) {
-                        printf("midplane port fails on port down with error = %d\n", test);
-                    }
-
-                    udelay(100000);
-
-                    temp = 0;   // clearing all bits in this register will result in an up (datasheet page 154)
-                    test = mdcio_write_reg(0, midplane_port, reg_num, temp);
-                    if(test) {
-                        printf("midplane port fails on port down with error = %d\n", test);
-                    }
-                }
-                
-        }
-        else if ( !strncmp(plat_str,"RazorM",6) || !strncmp(plat_str,"RazorS",6) ) {
- 
-                /* Set GPIO Port 3 Control to allow XDP Communication */
-                write32 (0x10200838, 0);
-
-                midplane_port=4;
-
-                //Midplane port down
-                test = mv88e6176_power_down(midplane_port, 1);
-                if(test) {
-                    printf("midplane port fails on port down with error = %d\n", test);
-                }
-
-                udelay(100000);
-
-                //Midplane port up
-                test = mv88e6176_power_down(midplane_port, 0);
-                if(test) {
-                    printf("midplane port fails on port down with error = %d\n", test);
-                }
-        }
 }
